<ng-container
  *ngTemplateOutlet="linkUrl ? linkTemplate : buttonTemplate"
></ng-container>

<ng-template #linkTemplate>
  <a
    [attr.data-cy]="id"
    [href]="linkUrl"
    [ngClass]="{ selected: selected && applySelectionStyle }"
    class="selectable-icon-text-button"
    rel="noopener noreferrer"
    target="_blank"
  >
    <lib-general-icon
      [name]="icon"
      [size]="iconFontSize.large"
      [type]="iconType.materialSymbolsOutlined"
      class="icon"
    ></lib-general-icon>
    <span [style.color]="color" class="button-text">{{ text }}</span>
  </a>
</ng-template>

<ng-template #buttonTemplate>
  <button
    (click)="onClick($event)"
    [attr.data-cy]="id"
    [ngClass]="{ selected: selected && applySelectionStyle }"
    class="selectable-icon-text-button"
    type="button"
  >
    <lib-general-icon
      [name]="icon"
      [size]="iconFontSize.large"
      [type]="iconType.materialSymbolsOutlined"
      class="icon"
    ></lib-general-icon>
    <span [style.color]="color" class="button-text">{{ text }}</span>
  </button>
</ng-template>
